<?php
include_once EX_CROSS_REF_PATH . 'sys/condition.class.php';
include_once EX_CROSS_REF_PATH . 'sys/datasource.class.php';
include_once EX_CROSS_REF_PATH . 'sys/databasedatasource.class.php';
include_once EX_CROSS_REF_PATH . 'sys/getmanager.class.php';
include_once EX_CROSS_REF_PATH . 'sys/table.class.php';

function ex_add_query_string($parameter_array) {
    $parameters = NULL;
    $query_string = $_SERVER['QUERY_STRING'];

    if ('' != $query_string) {
        $parameters = explode('&', $query_string);
    }

    $new_parameters = array();
    for ($i = 0; $i < count($parameters); $i++) {
        $parameter = explode('=', $parameters[$i]);
        $key = $parameter[0];
        $value = isset($parameter[1]) ? $parameter[1] : '';
        $new_parameters[$key] = $value;
    }

    foreach ($parameter_array as $p_key => $p_value) {
        $new_parameters[$p_key] = $p_value;
    }

    $new_query_string = http_build_query($new_parameters);

    return $new_query_string;
}

function ex_cross_ref_path() {
    return WP_PLUGIN_URL . '/' . CREF_FOLDER . '/';
}

function ex_cross_build_url($new_query_string_pram) {
    $query_string = ex_add_query_string($new_query_string_pram);
    $url = $_SERVER["SCRIPT_URI"];

    return $url . '?' . $query_string;
}

class ExCrossRefPostList {
    public function getColumns() {
        $post_title = __('Post Title','crossreferences');
        $post_action = __("Post Action", 'crossreferences');
        return array (
            'post_title' => array (
                'header' => $post_title,
                'cell_style' => 'text-align:left',
                'sortable' => TRUE,
                'function' => 'showPostTitle',
            ),
            'action' => array (
                'header' => $post_action,
                'function' => 'showAction',
            ),
        );
    }

    public function getDataSource() {
        global $wpdb;

        $wp_posts = $wpdb->prefix . 'posts';
        $wp_terms = $wpdb->prefix . 'terms';
        $wp_term_taxonomy = $wpdb->prefix . 'term_taxonomy';
        $wp_term_relationships = $wpdb->prefix . 'term_relationships';

        $sql = "SELECT {$wp_posts}.`ID`, {$wp_posts}.`post_title` FROM {$wp_posts}, $wp_terms, $wp_term_taxonomy, $wp_term_relationships WHERE {$wp_term_taxonomy}.`term_id` = {$wp_terms}.`term_id` AND {$wp_term_relationships}.`term_taxonomy_id` = {$wp_term_taxonomy}.`term_taxonomy_id` AND {$wp_posts}.`ID` = {$wp_term_relationships}.`object_id`";
        $action = empty($_GET['action']) ? 'all' : $_GET['action'];
        switch ($action) {
            case 'filter_by_cat':
                $term_id = $_GET['term_id'];
                $sql .= " AND {$wp_terms}.`term_id` = {$term_id} AND {$wp_term_taxonomy}.`taxonomy` = 'category' ";
                break;
            case 'filter_by_tag':
                $term_id = $_GET['term_id'];
                $sql .= " AND {$wp_terms}.`term_id` = {$term_id} AND {$wp_term_taxonomy}.`taxonomy` = 'post_tag' ";
                break;
            default:
                $sql = "SELECT `ID`, `post_title` FROM  $wp_posts WHERE `post_status` = 'publish' AND `post_type` = 'post'";
        }

        if (!empty($_POST['ex-cross-ref-search'])) {
            $search = $_POST['ex-cross-ref-search'];
            $sql .= "AND {$wp_posts}.`post_title` LIKE '%$search%'";
        }

        return new ExCrossRefDatabaseDataSource($sql, array('post_title' => 'asc'), array(0, 10));
    }

    public function showPostTitle($post_title, $row) {
        $url = ex_cross_build_url(array('action' => 'insert', 'history_post_id' => $row['ID']));
        return "<a href='{$url}'>$post_title</a>";
    }

    public function showAction($id, $row) {
        $url = ex_cross_build_url(array('action' => 'insert', 'history_post_id' => $row['ID']));
        return "<a href='{$url}'>" . __("Insert Post Link", 'crossreferences') . "</a>";
    }
}

function ex_cross_ref_media_buttons() {
    //empty here
}

function ex_cross_ref_media_buttons_context($context) {

    global $post_ID, $temp_ID;

    $uploading_iframe_ID = (int) (0 == $post_ID ? $temp_ID : $post_ID);

    $media_upload_iframe_src = "media-upload.php?post_id=$uploading_iframe_ID";

    $title = __('Insert Post Reference', 'crossreferences');

    $out = '<a href="' . $media_upload_iframe_src . '&tab=ex_cross_ref_list_pages&TB_iframe=true&height=520&width=840" class="thickbox" title="' . $title .
           '">' . __('Insert History Post Link', 'crossreferences') . '</a>';

    return $context . $out;
}

function ex_cross_ref_list_pages() {
    $post_list = new ExCrossRefPostList();
    $post_list_table = new ExCrossRefTable($post_list, $post_list->getColumns(), $post_list->getDataSource());
    $cats = get_categories();
    $tags = get_tags();

    $action = empty($_GET['action']) ? 'all' : $_GET['action'];
    if ('insert' == $action && !empty($_GET['history_post_id']) && !array_key_exists('history_post_alias', $_POST)) {
        include dirname(__FILE__) . '/ex-html-alias.php';
    }
    else if ('insert' == $action && !empty($_GET['history_post_id']) && array_key_exists('history_post_alias', $_POST)) {
        $history_post_id = $_GET['history_post_id'];

        $post = get_post($history_post_id);
        $post_alias = $_POST['history_post_alias'];

        if (empty($post_alias)) {
            media_send_to_editor("[cref {$post->post_name}]");
        }
        else {
            media_send_to_editor("[cref {$post->post_name} {$post_alias}]");
        }
    }
    else {
        include dirname(__FILE__) . '/ex-html.php';
    }
}
